Attribute VB_Name = "modMF"
' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2020

Option Explicit

' ----==== Const ====----
Public Const S_OK As Long = &H0&
Public Const VT_EMPTY As Integer = 0
Public Const MF_VERSION As Long = &H1&
Public Const MF_STARTUP_FULL As Long = &H0&
Public Const MF_OBJECT_INVALID As Long = &H2&
Public Const MF_OBJECT_MEDIASOURCE As Long = &H0&
Public Const MF_CLOCK_STATE_STOPPED As Long = &H2&
Public Const MF_RESOLUTION_MEDIASOURCE As Long = &H1&

Private Const CC_STDCALL As Long = &H4&
Private Const IID_Release As Long = &H8&

Public Const GUID_NULL As String = "{00000000-0000-0000-0000-000000000000}"

Public Const IID_IMFMediaSource As String = "{279A808D-AEC7-40C8-9C6B-A6B492C78A66}"
Public Const IID_IMFAttributes As String = "{2cd2d921-c447-44a7-a13c-4adabfc247e3}"

Public Const MF_BYTESTREAM_CONTENT_TYPE As String = "{fc358289-3cb6-460c-a424-b6681260375a}"

Public Const MF_TRANSCODE_CONTAINERTYPE As String = "{150ff23f-4abc-478b-ac4f-e1916fba1cca}"

Public Const MF_PD_DURATION As String = "{6C990D33-BB8E-477A-8598-0D5D96FCD88A}"

Public Const MF_MT_SUBTYPE As String = "{f7e34c9a-42e8-4714-b74b-cb29d72c35e5}"
Public Const MF_MT_AUDIO_SAMPLES_PER_SECOND As String = "{5faeeae7-0290-4c31-9e8a-c534f68d9dba}"
Public Const MF_MT_AUDIO_NUM_CHANNELS As String = "{37e48bf5-645e-4c5b-89de-ada9e29b696a}"
Public Const MF_MT_AUDIO_AVG_BYTES_PER_SECOND As String = "{1aab75c8-cfef-451c-ab95-ac034b8e1731}"
Public Const MF_MT_AUDIO_BITS_PER_SAMPLE As String = "{f2deb57f-40fa-4764-aa33-ed4f2d1ff669}"
Public Const MF_MT_AUDIO_BLOCK_ALIGNMENT As String = "{322de230-9eeb-43bd-ab7a-ff412251541d}"
Public Const MF_MT_AAC_AUDIO_PROFILE_LEVEL_INDICATION As String = "{7632f0e6-9538-4d61-acda-ea29c8c14456}"
Public Const MF_MT_ALL_SAMPLES_INDEPENDENT = "{C9173739-5E56-461C-B713-46FB995CB95F}"
Public Const MF_MT_AUDIO_VALID_BITS_PER_SAMPLE = "{D9BF8D6A-9530-4B7C-9DDF-FF6FD58BBD06}"

'MP3
Public Const MFAudioFormat_MP3 As String = "{00000055-0000-0010-8000-00aa00389b71}"
Public Const MFTranscodeContainerType_MP3 As String = "{e438b912-83f1-4de6-9e3a-9ffbc6dd24d1}"

'MP4
Public Const MFAudioFormat_AAC As String = "{00001610-0000-0010-8000-00aa00389b71}"
Public Const MFTranscodeContainerType_MPEG4 As String = "{dc6cd05d-b9d0-40ef-bd35-fa622c1ab28a}"

'Flac
Public Const MFAudioFormat_FLAC As String = "{0000f1ac-0000-0010-8000-00aa00389b71}"
Public Const MFTranscodeContainerType_FLAC As String = "{31344aa3-05a9-42b5-901b-8e9d4257f75e}"

' ----==== Enums ====----
Public Enum vtb_Interfaces
    
    'IUnknown
    QueryInterface = 0
        
    'IStream
    Write_Stream = 4
        
    'IMFSourceResolver
    CreateObjectFromByteStream = 4

    'IMFMediaSource
    CreatePresentationDescriptor = 8
    Shutdown_Source = 12
        
    'IMFClock
    GetCorrelatedTime = 4
    GetState = 6
        
    'IMFMediaSession
    SetTopology = 7
    Start_Session = 9
    Close_Session = 12
    Shutdown_Session = 13
    GetClock = 14
        
    'IMFPresentationDescriptor
    GetUINT64 = 8
        
    'IMFAttributes
    SetUINT32 = 21
    SetGUID = 24
    SetString = 25
    
    'IMFTranscodeProfile
    SetAudioAttributes = 3
    SetContainerAttributes = 7
    
End Enum

' ----==== Type ====----
Public Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

Public Type PROPVARIANT
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As Long
    Padding As Long
End Type

' ----==== Kernel32.dll Deklarationen ====----
Private Declare Sub Sleep Lib "Kernel32.dll" ( _
                    ByVal lngMilliseconds As Long)

' ----==== Shlwapi.dll Deklarationen ====----
Public Declare Function SHCreateMemStream Lib "Shlwapi.dll" ( _
                        ByVal pInit As Long, _
                        ByVal cbInit As Long) As Long

' ----==== Ole32 API-Deklarationen ====----
Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long

' ----==== Oleaut32.dll Deklarationen ====----
Private Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Long, _
                         ByVal prgpvarg As Long, _
                         ByRef pvargResult As Variant) As Long

' ----==== Mfplat.dll Deklarationen ====----
Public Declare Function MFStartup Lib "Mfplat.dll" ( _
                        ByVal Version As Long, _
                        ByVal dwFlags As Long) As Long

Public Declare Function MFShutdown Lib "Mfplat.dll" () As Long

Public Declare Function MFCreateSourceResolver Lib "Mfplat.dll" ( _
                        ByRef ppISourceResolver As Long) As Long

Public Declare Function MFCreateAttributes Lib "Mfplat.dll" ( _
                        ByRef ppMFAttributes As Long, _
                        ByVal cInitialSize As Long) As Long

Public Declare Function MFCreateMFByteStreamOnStream Lib "Mfplat.dll" ( _
                        ByVal pStream As Long, _
                        ByRef ppByteStream As Long) As Long

' ----==== Mf.dll Deklarationen ====----
Public Declare Function MFCreateTranscodeProfile Lib "Mf.dll" ( _
                        ByRef ppTranscodeProfile As Long) As Long

Public Declare Function MFCreateTranscodeTopology Lib "Mf.dll" ( _
                        ByVal pSrc As Long, _
                        ByVal pwszOutputFilePath As Long, _
                        ByVal pProfile As Long, _
                        ByRef ppTranscodeTopo As Long) As Long

Public Declare Function MFCreateMediaSession Lib "Mf.dll" ( _
                        ByVal pConfiguration As Long, _
                        ByRef ppMediaSession As Long) As Long

' ----==== Call OleInvoke ====----
Public Function Invoke(ByVal pInterface As Long, ByVal vtb As vtb_Interfaces, _
    ParamArray var()) As Variant

    If pInterface <> 0& Then

        Invoke = OleInvoke(pInterface, vtb, var)

    End If

End Function

' ----==== Release Interface ====----
Public Sub Release(ByRef pInterface As Long)

    Dim vRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, vRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' ----==== Call Interface Function ====----
Private Function OleInvoke(ByVal pInterface As Long, ByVal lCmd As Long, _
    ParamArray aParam()) As Variant
    
    Dim lCount As Long
    Dim lItem As Long
    Dim vRet As Variant
    Dim vParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer

    ' wenn ein Pointer auf ein Interface vorhanden ist
    If pInterface <> 0& Then

        ' nur wenn zum Aufruf der Interface-Funktion auch
        ' Parameter vorhanden sind.
        If UBound(aParam) >= 0 Then

            ' ParamArray nach Variant
            vParam = aParam

            ' ist der Variant ein Array
            If IsArray(vParam) Then vParam = vParam(0)

            ' Anzahl der Parameter
            lCount = UBound(vParam)

            ' alle Parameter durchlaufen
            For lItem = 0 To lCount

                ' Typ des Parameter
                oleTyp(lItem) = VarType(vParam(lItem))

                ' Pointer auf den Parameter
                olePtr(lItem) = VarPtr(vParam(lItem))

            Next

        End If

        ' Funktion des Interfaces aufrufen
        If DispCallFunc(pInterface, lCmd * 4, CC_STDCALL, vbLong, _
            lItem, VarPtr(oleTyp(0)), VarPtr(olePtr(0)), vRet) <> S_OK Then
            
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"

        End If

    End If

    OleInvoke = vRet

End Function

' ----==== String -> GUID ====----
Public Function Str2Guid(ByVal str As String) As GUID

    Call CLSIDFromString(StrPtr(str), Str2Guid)
    
End Function

' ----==== Delay ====----
Public Sub Delay(ByVal SecsDelay As Single)

    Dim TimeOut   As Single
    Dim PrevTimer As Single

    PrevTimer = Timer
    TimeOut = PrevTimer + SecsDelay

    Do While PrevTimer < TimeOut

        Call Sleep(1)

        DoEvents

        If Timer < PrevTimer Then TimeOut = TimeOut - 86400

        PrevTimer = Timer

    Loop

End Sub

Public Function EncodeStream(ByVal pStream As Long, _
    ByVal sStreamMimeType As String, _
    ByVal szOutput As String) As Boolean

    Dim pByteStream As Long
    Dim pProfile As Long
    Dim pSource As Long
    Dim pTopology As Long
    Dim pSession As Long
    Dim pClock As Long
    Dim lngZahl As Long
    Dim bStatus As Boolean
    Dim duration As Currency
    Dim pos As Currency
    Dim lState As Long
    Dim bolRet As Boolean
    bolRet = False
    
    ' IStream -> IMFByteStream
    If MFCreateMFByteStreamOnStream(pStream, _
        pByteStream) = S_OK Then
    
        If CreateMediaSourceFromStream(pByteStream, _
            sStreamMimeType, pSource) = True Then
    
            If GetSourceDuration(pSource, duration) = True Then
        
                If CreateMP3TranscodeProfile(pProfile) = True Then
                
                ' Weitere Mglichkeiten in die man konvertieren kann.
                ' Es gibt noch weitere Formate.
                ' If CreateMP4TranscodeProfile(pProfile) = True Then
                ' If CreateFlacTranscodeProfile(pProfile) = True Then
                
                    If MFCreateTranscodeTopology(pSource, StrPtr(szOutput), _
                        pProfile, pTopology) = S_OK Then
                
                        If CreateMediaSession(pSession, pClock) = True Then
                    
                            If StartEncodingSession(pSession, pTopology) = True Then
                    
                                Do

                                    If GetEncodingPosition(pClock, pos) = True Then
                                
                                        ' Debug.Print pos, duration
                                
                                    End If
                                    
                                    If GetEncodingStatus(pClock, lState) = True Then
                                
                                        If lState = MF_CLOCK_STATE_STOPPED Then
                                    
                                            bolRet = True
                                        
                                        End If
                                    
                                    End If
                                
                                Loop Until bolRet = True
    
                            End If
                        
                        End If
        
                    End If
        
                End If
            
            End If
        
        End If
    
    End If
    
    
    Call Invoke(pSession, Close_Session)
    Call Delay(0.05)
    Call Invoke(pSource, Shutdown_Source)
    Call Delay(0.05)
    Call Invoke(pSession, Shutdown_Session)
    Call Delay(0.05)

    Call Release(pClock)
    Call Release(pSession)
    Call Release(pProfile)
    Call Release(pSource)
    Call Release(pTopology)
    Call Release(pByteStream)
    
    EncodeStream = bolRet

End Function

Private Function CreateMediaSourceFromStream(ByVal pByteStream As Long, _
    ByVal sByteStreamMimeType As String, _
    ByRef ppSource As Long) As Boolean
    
    Dim pSource As Long
    Dim pResolver As Long
    Dim bolRet As Boolean
    Dim ObjectType As Long
    Dim pIMFAttributes As Long
    
    bolRet = False
    
    ObjectType = MF_OBJECT_INVALID
    
    If MFCreateSourceResolver(pResolver) = S_OK Then
    
        If Invoke(pByteStream, QueryInterface, _
            VarPtr(Str2Guid(IID_IMFAttributes)), _
            VarPtr(pIMFAttributes)) = S_OK Then
            
            If Invoke(pIMFAttributes, SetString, _
                VarPtr(Str2Guid(MF_BYTESTREAM_CONTENT_TYPE)), _
                StrPtr(sByteStreamMimeType)) = S_OK Then
                
                If Invoke(pResolver, CreateObjectFromByteStream, pByteStream, _
                    0&, MF_RESOLUTION_MEDIASOURCE, 0&, VarPtr(ObjectType), _
                    VarPtr(pSource)) = S_OK Then
                    
                    If ObjectType = MF_OBJECT_MEDIASOURCE Then
                    
                        If Invoke(pSource, QueryInterface, _
                            VarPtr(Str2Guid(IID_IMFMediaSource)), _
                            VarPtr(ppSource)) = S_OK Then
                            
                            bolRet = True
                            
                        End If
                        
                    End If
                    
                End If
                
            End If
            
        End If
        
    End If
    
    Call Release(pIMFAttributes)
    Call Release(pResolver)
    Call Release(pSource)
    
    CreateMediaSourceFromStream = bolRet
    
End Function

Private Function GetSourceDuration(ByVal pSource As Long, _
    ByRef pDuration As Currency) As Boolean

    Dim pPD As Long
    Dim bolRet As Boolean

    bolRet = False

    If Invoke(pSource, CreatePresentationDescriptor, VarPtr(pPD)) = S_OK Then

        If Invoke(pPD, GetUINT64, VarPtr(Str2Guid(MF_PD_DURATION)), _
            VarPtr(pDuration)) = S_OK Then

            bolRet = True
            pDuration = pDuration * 10000

        End If

    End If

    Call Release(pPD)

    GetSourceDuration = bolRet

End Function

Private Function CreateMediaSession(ByRef pSession As Long, _
    ByRef pClock As Long) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If MFCreateMediaSession(0&, pSession) = S_OK Then

        If Invoke(pSession, GetClock, VarPtr(pClock)) = S_OK Then

            bolRet = True

        End If

    End If

    CreateMediaSession = bolRet

End Function

Private Function StartEncodingSession(ByVal pSession As Long, _
    ByVal pTopology As Long) As Boolean

    Dim bolRet As Boolean
    Dim tPROPVARIANT As PROPVARIANT
    
    bolRet = False

    If Invoke(pSession, SetTopology, 0&, pTopology) = S_OK Then
    
        With tPROPVARIANT
            .vt = VT_EMPTY
            .vData = 0&
        End With

        If Invoke(pSession, Start_Session, VarPtr(Str2Guid(GUID_NULL)), _
            VarPtr(tPROPVARIANT)) = S_OK Then

            bolRet = True

        End If

    End If

    StartEncodingSession = bolRet

End Function

Private Function GetEncodingPosition(ByVal pClock As Long, _
    ByRef curPos As Currency) As Boolean

    Dim clockTime As Currency
    Dim systemTime As Currency
    Dim bolRet As Boolean
    
    bolRet = False

    If Invoke(pClock, GetCorrelatedTime, 0&, VarPtr(clockTime), _
        VarPtr(systemTime)) = S_OK Then
    
        bolRet = True
        curPos = clockTime * 10000
        
    End If
    
    GetEncodingPosition = bolRet
    
End Function

Private Function GetEncodingStatus(ByVal pClock As Long, _
    ByRef lState As Long) As Boolean

    Dim bolRet As Boolean
    
    bolRet = False

    If Invoke(pClock, GetState, 0&, VarPtr(lState)) = S_OK Then
    
        bolRet = True
        
    End If
    
    GetEncodingStatus = bolRet
    
End Function

Private Function CreateMP3TranscodeProfile(ByRef ppProfile As Long) As Boolean

    Dim pAudio As Long
    Dim pProfile As Long
    Dim pContainer As Long
    Dim bolRet As Boolean

    bolRet = False

    If MFCreateTranscodeProfile(pProfile) = S_OK Then
    
        If CreateMP3Profile(pAudio) = True Then
            
            If Invoke(pProfile, SetAudioAttributes, pAudio) = S_OK Then
                        
                If MFCreateAttributes(pContainer, 1&) = S_OK Then
                
                    If Invoke(pContainer, SetGUID, _
                        VarPtr(Str2Guid(MF_TRANSCODE_CONTAINERTYPE)), _
                        VarPtr(Str2Guid(MFTranscodeContainerType_MP3))) = S_OK Then
                                                
                        If Invoke(pProfile, SetContainerAttributes, _
                            pContainer) = S_OK Then
                        
                            bolRet = True
                            ppProfile = pProfile
                    
                        End If
                        
                    End If
                
                End If
    
            End If
            
        End If
    
    End If

    Call Release(pAudio)
    Call Release(pContainer)
    
    CreateMP3TranscodeProfile = bolRet
    
End Function

Private Function CreateMP3Profile(ByRef ppAttributes As Long) As Boolean
    
    Dim pAttributes As Long
    Dim bolRet As Boolean

    bolRet = False

    If MFCreateAttributes(pAttributes, 4) = S_OK Then
    
        If Invoke(pAttributes, SetGUID, _
            VarPtr(Str2Guid(MF_MT_SUBTYPE)), _
            VarPtr(Str2Guid(MFAudioFormat_MP3))) = S_OK Then

            If Invoke(pAttributes, SetUINT32, _
                VarPtr(Str2Guid(MF_MT_AUDIO_SAMPLES_PER_SECOND)), _
                CLng(44100)) = S_OK Then
                    
                If Invoke(pAttributes, SetUINT32, _
                    VarPtr(Str2Guid(MF_MT_AUDIO_NUM_CHANNELS)), _
                    CLng(2)) = S_OK Then
                    
                    If Invoke(pAttributes, SetUINT32, _
                        VarPtr(Str2Guid(MF_MT_AUDIO_AVG_BYTES_PER_SECOND)), _
                        CLng(32000)) = S_OK Then
                                        
                        bolRet = True
                        ppAttributes = pAttributes
                                        
                    End If
                        
                End If
            
            End If
                
        End If
            
    End If
    
    CreateMP3Profile = bolRet
    
End Function

Private Function CreateMP4TranscodeProfile(ByRef ppProfile As Long) As Boolean

    Dim pAudio As Long
    Dim pProfile As Long
    Dim pContainer As Long
    Dim bolRet As Boolean

    bolRet = False

    If MFCreateTranscodeProfile(pProfile) = S_OK Then
    
        If CreateMP4Profile(1&, pAudio) = True Then
        
            If Invoke(pProfile, SetAudioAttributes, pAudio) = S_OK Then
            
                If MFCreateAttributes(pContainer, 1&) = S_OK Then
                
                    If Invoke(pContainer, SetGUID, _
                        VarPtr(Str2Guid(MF_TRANSCODE_CONTAINERTYPE)), _
                        VarPtr(Str2Guid(MFTranscodeContainerType_MPEG4))) = S_OK Then
                        
                        If Invoke(pProfile, SetContainerAttributes, pContainer) = S_OK Then
                        
                            bolRet = True
                            ppProfile = pProfile
                    
                        End If
                        
                    End If
                
                End If
    
            End If
            
        End If
    
    End If

    Call Release(pAudio)
    Call Release(pContainer)
    
    CreateMP4TranscodeProfile = bolRet
    
End Function

Private Function CreateMP4Profile(ByVal index As Long, ByRef ppAttributes As Long) As Boolean
   
    
    Dim pAttributes As Long
    Dim bolRet As Boolean

    bolRet = False

    If MFCreateAttributes(pAttributes, 7) = S_OK Then
    
        If Invoke(pAttributes, SetGUID, _
            VarPtr(Str2Guid(MF_MT_SUBTYPE)), _
            VarPtr(Str2Guid(MFAudioFormat_AAC))) = S_OK Then

            If Invoke(pAttributes, SetUINT32, _
                VarPtr(Str2Guid(MF_MT_AUDIO_BITS_PER_SAMPLE)), _
                CLng(16)) = S_OK Then

                If Invoke(pAttributes, SetUINT32, _
                    VarPtr(Str2Guid(MF_MT_AUDIO_SAMPLES_PER_SECOND)), _
                    CLng(44100)) = S_OK Then
                    
                    If Invoke(pAttributes, SetUINT32, _
                        VarPtr(Str2Guid(MF_MT_AUDIO_NUM_CHANNELS)), _
                        CLng(2)) = S_OK Then
                    
                        If Invoke(pAttributes, SetUINT32, _
                            VarPtr(Str2Guid(MF_MT_AUDIO_AVG_BYTES_PER_SECOND)), _
                            CLng(20000)) = S_OK Then
                        
                            If Invoke(pAttributes, SetUINT32, _
                                VarPtr(Str2Guid(MF_MT_AUDIO_BLOCK_ALIGNMENT)), _
                                1&) = S_OK Then
                        
                                If Invoke(pAttributes, SetUINT32, _
                                    VarPtr(Str2Guid(MF_MT_AAC_AUDIO_PROFILE_LEVEL_INDICATION)), _
                                    &H29&) = S_OK Then
                        
                                    bolRet = True
                                    ppAttributes = pAttributes
                        
                                End If
                                
                            End If
                    
                        End If
                    
                    End If
            
                End If
                
            End If
            
        End If
    
    End If
    
    CreateMP4Profile = bolRet
    
End Function

Private Function CreateFlacTranscodeProfile(ByRef ppProfile As Long) As Boolean

    Dim pAudio As Long
    Dim pProfile As Long
    Dim pContainer As Long
    Dim bolRet As Boolean

    bolRet = False

    If MFCreateTranscodeProfile(pProfile) = S_OK Then
    
        If CreateFlacProfile(pAudio) = True Then
            
            If Invoke(pProfile, SetAudioAttributes, pAudio) = S_OK Then
                        
                If MFCreateAttributes(pContainer, 1&) = S_OK Then
                
                    If Invoke(pContainer, SetGUID, _
                        VarPtr(Str2Guid(MF_TRANSCODE_CONTAINERTYPE)), _
                        VarPtr(Str2Guid(MFTranscodeContainerType_FLAC))) = S_OK Then
                                                
                        If Invoke(pProfile, SetContainerAttributes, pContainer) = S_OK Then
                        
                            bolRet = True
                            ppProfile = pProfile
                    
                        End If
                        
                    End If
                
                End If
    
            End If
            
        End If
    
    End If

    Call Release(pAudio)
    Call Release(pContainer)
    
    CreateFlacTranscodeProfile = bolRet
    
End Function

Private Function CreateFlacProfile(ByRef ppAttributes As Long) As Boolean
   
    
    Dim pAttributes As Long
    Dim bolRet As Boolean

    bolRet = False

    If MFCreateAttributes(pAttributes, 7) = S_OK Then
    
        If Invoke(pAttributes, SetGUID, _
            VarPtr(Str2Guid(MF_MT_SUBTYPE)), _
            VarPtr(Str2Guid(MFAudioFormat_FLAC))) = S_OK Then
            
            If Invoke(pAttributes, SetUINT32, _
                VarPtr(Str2Guid(MF_MT_AUDIO_BITS_PER_SAMPLE)), _
                CLng(24)) = S_OK Then

                If Invoke(pAttributes, SetUINT32, _
                    VarPtr(Str2Guid(MF_MT_AUDIO_SAMPLES_PER_SECOND)), _
                    CLng(44100)) = S_OK Then
                    
                    If Invoke(pAttributes, SetUINT32, _
                        VarPtr(Str2Guid(MF_MT_AUDIO_NUM_CHANNELS)), _
                        CLng(2)) = S_OK Then
                    
                        If Invoke(pAttributes, SetUINT32, _
                            VarPtr(Str2Guid(MF_MT_AUDIO_AVG_BYTES_PER_SECOND)), _
                            CLng(16000)) = S_OK Then
                        
                            If Invoke(pAttributes, SetUINT32, _
                                VarPtr(Str2Guid(MF_MT_ALL_SAMPLES_INDEPENDENT)), _
                                CLng(1)) = S_OK Then
                        
                                If Invoke(pAttributes, SetUINT32, _
                                VarPtr(Str2Guid(MF_MT_AUDIO_VALID_BITS_PER_SAMPLE)), _
                                CLng(24)) = S_OK Then
                                        
                                    bolRet = True
                                    ppAttributes = pAttributes
                                        
                                 End If
                                 
                            End If

                        End If
                            
                    End If
                        
                End If
            
            End If
                
        End If
            
    End If
    
    CreateFlacProfile = bolRet
    
End Function

